﻿#targetengine "session"

var script = {
	name: 'flashViewer',
	version: 1.15,
	autor: 'Alex Den',
	mail: 'alexden.js@gmail.com',
	sites: [
		'www.scriptuibuilder.com',
		'www.sites.google.com/site/scriptuibuilder/'
		],
	release: 2009,
	supportApp: [
		'InDesign5',
		'Photoshop10',
		'Illustrator13',
		'InDesign6',
		'Photoshop11',
		'Illustrator14',
		],
	supportFS: [
		'Windows',
		'Macintosh'
		],
	//============= Script =============================
	file: app.activeScript || File($.fileName),
	fullName: function(){return this.name+' v.'+this.version},
	alertError: function(err){
		try{
		var Str=err+'\r';
		Str+='string: '+err.line+'\r\r';
		Str+='========= SYSTEM ========\r';
		Str+= this.fullName()+'\r';
		Str+= this.getSystemInfo()+'\r';
		Str+='=======================\r';
		Str+='Please, make a picture of this screen \rand send it by '+this.mail+'\r';
		Str+='Close the program.';
		alert(Str, 'error', true);
		}catch(err){alert(err + '\r' + err.line)}
		},
	systemCheck: function(){
		var support = false;
		var thisApp = this.appName+this.appVersion;
		for(var i=0;i<this.supportApp.length;i++)
			if(thisApp == this.supportApp[i]){
				support = true;
				break;
				}
		for(var i=0;i<this.supportFS.length;i++){
			if(File.fs == this.supportFS[i]){
				support = true;
				break;
				}
			support = false;
			}
		if(support)
			return true;
		alert ('This version of a script is not supported:\r'+this.appName+' '+app.version + '\r\r======================\r'+this.fullInfo(), 'error', true);
		return false;
		},
	//============= Info =============================
	supportInfo: function(){
		try{
		var cs = [false, false];
		var supApps = [false, false, false];
		for(var i = 0;i<this.supportApp.length; i++)
			switch(this.supportApp[i]){
				case 'InDesign5':
				cs[0] = 'CS3';
				supApps[0] = 'InDesig';
				break;
				case 'Photoshop10':
				cs[0] = 'CS3';
				supApps[1] = 'Photoshop';
				break;
				case 'Illustrator13':
				cs[0]= 'CS3';
				supApps[2] = 'Illustrator';
				break;
				case 'InDesign6':
				cs[1] = 'CS4';
				supApps[0] = 'InDesign';
				break;
				case 'Photoshop11':
				cs[1] = 'CS4';
				supApps[1] = 'Photoshop';
				break;
				case 'Illustrator14':
				cs[1] = 'CS4';
				supApps[2] = 'Illustrator';
				}
		var str = this.getListForSupportInfo(supApps) + ' ';
		str += this.getListForSupportInfo(cs) + ' ';
		str += this.getListForSupportInfo(this.supportFS);
		return str;
		}catch(err){this.alertError(err)}
		},
	getListForSupportInfo: function(array){
		try{
		var str = '';
		var i = 0;
		var slash = '';
		do{
			if(array[i]){
				str += slash + array[i];
				slash = '/';
				}
			i++;
			} while(array.length > i);
		return str;
		}catch(err){this.alertError(err)}
		},
	fullInfo: function(){
		return this.fullName()+'\r'+
			'for '+this.supportInfo()+'\r\r'+
			'script of '+this.autor+', '+this.release+'\r'+
			this.mail+'\r'+
			this.sites.join('\r');
		},
	getWinInfo: function( str ){
		try{
		var str = str||'';
		if(str) str = '\r\r' + str;
		var thisSite = ( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 ) ? false : this.sites[0];
		var addScriptInfo = function( container ){
			var item;
			with(container){
				item = add('statictext', undefined, container.window.core.fullInfo() + str, {multiline: true});
				
				var buts = add('group');
				buts.orientation = 'row';
				buts.alignment = 'right';
				buts.margins = [0,10,0,10];
				if( thisSite ){
					var site = buts.add('button', undefined, thisSite);
					site.onClick = function(){
						this.window.core.connectToSite();
						this.window.close();
						}
					}
				var news = buts.add('button', undefined, 'News');
				news.onClick = function(){
					this.window.core.newsService();
					this.window.close();
					}
				}
			}
		var addSystemInfo = function( container ){
			var item = container.add('statictext', undefined, container.window.core.getSystemInfo(), {multiline: true});
			}
		var winInfo = new Window('dialog', 'Info');
		winInfo.core = this;
		winInfo.preferredSize = [400,10];
		winInfo.alignChildren = 'fill';
		winInfo.margins = 5;
		winInfo.spacing = 5;
		if(this.appVersionCS() == 4){//CS4
			with(winInfo){
				winInfo.tPnl = add('tabbedpanel');
				with(winInfo.tPnl){
					winInfo.tPnl.script = add('tab', undefined, 'Script');
					winInfo.tPnl.script.orientation = 'column';
					winInfo.tPnl.script.alignChildren = 'fill';
					addScriptInfo( winInfo.tPnl.script );
					
					winInfo.tPnl.system = add('tab', undefined, 'System');
					winInfo.tPnl.system.orientation = 'column';
					winInfo.tPnl.system.alignChildren = 'fill';
					addSystemInfo( winInfo.tPnl.system );
					}
				}
			}
		else{//CS3
			addScriptInfo( winInfo );
			winInfo.tPnl = winInfo.add('panel', undefined, 'System');
			winInfo.tPnl.alignChildren = 'fill';
			addSystemInfo( winInfo.tPnl );
			}
		winInfo.ok = winInfo.add('button', undefined, 'OK');
		winInfo.ok.alignment = 'center';
		winInfo.ok.onClick = function(){
			this.window.close();
			}
		winInfo.center();
		winInfo.show();
		}catch(err){this.alertError(err)};
		},
	getSystemInfo: function(){
		var str = '';
		try{
		str+=$.os+'\r';
		str+=this.appName+' '+this.appVersion+'\r';
		str+='Language: '+$.locale+'\r';
		str+='ScriptUI: '+ScriptUI.version;
		return str;
		} catch (Error) { return str }
		},
	connectToSite: function(){
		if( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 )
			return;
		var thisSite = this.sites[0];
		var urlFile = File(Folder.temp.fsName + '/'+this.adaptForFileName(thisSite)+'.url');
		if(!urlFile.exists)
			this.fileWrite( urlFile, '[DEFAULT]\rBASEURL=http://'+thisSite+'/\r[InternetShortcut]\rURL=http://'+thisSite+'/' );
		try{
			urlFile.execute();
			} catch(err) {this.alertError(err)}
		},
	newsService: function(){
		try{
		if( this.appName == 'Illustrator' ){
			alert( "Error.\rAdobe Illustrator don't support TCP-connection through Socket object." )
			return;
			}
		var address = 'scriptuibuilder.com';
		var path = 'news.html';
		var socket = new Socket;
		socket.timeout = 120;
		if ( !socket.open( address + ':80' ) ){
			alert('Error of connecting with scriptuibuilder.com');
			return;
			}
		var request = 
			"GET /" + path + " HTTP/1.1\n" +
			"Host: " + address + "\n" +
			"User-Agent: "+this.fullName()+"("+this.appName+this.appVersion+")\n" +
			"Accept: text/plain\n" + 
			"Accept-Encoding:\n" +
			"Connection: keep-alive\n" +
			"Accept-Language: *\n" + 
			"Accept-Charset: utf-8\n\n";
		socket.write(request);
		var data = '';
		while(!socket.eof)
			data += socket.read();
		socket.close();
		data = data.split('\n');//переводим строку в массив
		var tagData = this.getTagArray( data, 'news' );
		if( !tagData ){
			alert('Error of data');
			return;
			}
		this.getReportWindow( tagData.join('\r'), 'News Service scriptuibuilder.com' );
		}catch(err){this.alertError(err); };
		},
	getTagArray: function( array, tag ){//возвращает массив между тэгами <tag> и </tag>, для ф-ции newsService, пропускает строки, начинающиеся с //
		try{
		var index = {start: -1, end: -1};
		var tag = {open: '<'+tag+'>', close: '</'+tag+'>'};
		for (var i = 0; i < array.length; i++){
			if ( array[i] == tag.open )
				index.start = i + 1;
			if ( array[i] == tag.close ){
				index.end = i;
				break;
				}
			}
		if( index.start < 0 || index.end < 0 )
			return '';
		var res = array.slice(index.start, index.end);
		for (var i = res.length; i >= 0; i--)
			if( /^\/\//.test(res[i]) )
				res.splice( i, 1 );
		return res;
		}catch(err){this.alertError(err);};
		},
	//============= preferences =============================
	prefSave: function( string, encode ){
		if( this.appName == 'InDesign' ){
			try{
			app.insertLabel( this.adaptForFileName(this.name), string );
			return true;
			}catch(err){}
			}
		return this.fileWrite( this.getPrefFile(), string, encode );
		},
	prefRead: function( decode ){
		if( this.appName == 'InDesign' ){
			var result = app.extractLabel( this.adaptForFileName(this.name) );
			if( result )
				return result;
			}
		var file = this.getPrefFile();
		if( !file.exists )
			return false;
		return this.fileRead( file, decode );
		},
	getPrefFolder: function(){
		var folder = Folder( Folder.userData.fsName + '/Adobe/' + this.adaptForFileName(this.autor) + '_Scripts/' + this.name );
		if( !folder.exists ) folder.create();
		return folder;
		},
	getPrefFile: function(){
		return File(this.getPrefFolder().fsName+'/preferences_v.'+this.adaptForFileName(this.version)+'_'+this.appName+this.appVersion+'.txt');
		},
	resourcesFolder: function(){
		var folder = Folder(this.getPrefFolder().fsName + '/resources');
		if( !folder.exists ) folder.create();
		return folder;
		},
	//============= file system =============================
	fileRead: function( file, decode ){
		if(!file.exists){
			alert( 'File not found:\n\n'+file.fsName, 'Error', true );
			return false;
			}
		var result = false;
		try{
		file.open( 'r' );
		var result = file.read();
		result = decode ? decodeURI( result ) : result;
		}catch( err ){ 
			this.alertError( err ); 
			result = false; 
			}
		finally{
		file.close();
		}
		return result;
		},
	fileWrite: function( file, string, encode ){
		var result = false;
		string = encode ? encodeURI( string ) : string;
		try{
		if( !encode && File.fs == 'Macintosh' ){
			string = String( string );
			var oldStr = '';
			if(file.exists){
				file.open("r");
				oldStr = file.read();
				file.close();
				}
			if(string == oldStr)
				result = true;
			file.open("w");
			if(!file.write(string)){
				file.write(oldStr);
				file.close();
				alert('Error writing file!\n\nFile:\n' + file.fsName);
				result = false;
				}
			}
		else{
			file.open( 'w' );
			result = file.write( string );
			}
		}catch( err ){ 
			this.alertError( err ); 
			result = false; 
			}
		finally{
		file.close();
		}
		return result;
		},
	adaptForFileName: function(str){
		return str.toString().replace(/[ \\\/:*?"<>|]/g, '_');
		},
	adaptFsNameForSave: function(fsName){
		return fsName.replace(/\\/g, '/').replace(/\'/g, '\\\'');
		},
	getDisplayName: function(fsObject){
		return fsObject.fsName.split(/[\\\/]/).reverse()[0];
		},
	getFileAlias: function(folder, file, create){
		try{
		var aliases = folder.getFiles(function(file){return file.alias});
		var fileLink = file.fsName;
		for(var i = 0; i < aliases.length; i++)
			if(aliases[i].resolve().fsName == fileLink)
				return aliases[i];
		if(create){
			if(!folder.exists)
				folder.create();
			if(File.fs == 'Macintosh'){
				alert('For MacOS: \ryou yourself must create alias in the folder:\r' + folder.fsName);
				return false;
				}
			var alias = new File(folder.fsName + '/'  + this.getDisplayName(file));
			alias.createAlias(file);
			return alias;
			}
		return false;
		}catch(err){this.alertError(err)};
		},
	//============= application data =============================
	appName: app.name.replace('Adobe ',''),
	appVersion: app.version.replace(/^(\d+)\..+$/,'$1'),
	appVersionCS: function(){
		switch( this.appName ){
			case 'InDesign':
			return this.appVersion - 2;
			case 'Photoshop':
			return this.appVersion - 7;
			case 'Illustrator':
			return this.appVersion - 10;
			default:
			return 0;
			}
		},
	getStartupFolder: function(){
		var folder = Folder((app.filePath || app.path) + ((this.appName == 'InDesign')?'/Scripts':'') + '/Startup Scripts');
		if(!folder.exists)
			folder.create();
		return folder;
		},
	//============= scriptUI =============================
	images: [],
	writeImage: function(codeStr, name){
		var folder = this.resourcesFolder();
		if(!folder.exists)
			folder.create();
		var pngFile = new File(folder.fsName + '/' + name + '.png');
		if(!pngFile.exists){
			pngFile.encoding = "BINARY";
			if(!this.fileWrite(pngFile, codeStr)){
				this.images[name] = false;
				return false;
				}
			}
		this.images[name] = ScriptUI.newImage(pngFile.fsName);
		return this.images[name];
		},
	
	getUiObjectIndex: function(uiObject){
		try{
		for(var i = 0; i < uiObject.parent.children.length; i++)
			if(uiObject.parent.children[i] == uiObject)
				return i;
		}catch(err){this.alertError(err)};
		},
	getCustomDraw: function( uiObject, args ){// args = { text: 'myButton', font: 'Tahoma', style: 'Bold', size: 12, textRGB: [0,0,0], bgRGB: [0,0,0] } - добавление текста в uiObject (напр., для добавления текста в iconbutton) и раскраска элемента
		try{
		if( !args )//обнуление, убирает ранее установленное форм-ние (текст и цвет)
			args = {}
		var str = '';
		str += 'uiObject.onDraw = function(){';
		str += 'this.graphics.drawOSControl();';
		if(args.text){
			args.textRGB = args.textRGB || [0,0,0];//по умолчанию - Black
			this.addFont( uiObject, args );
			str += 'var textSize = this.graphics.measureString( \''+args.text+'\' );';
			str += 'var x = Math.max(0, (this.size[0] - textSize[0])/2);';
			str += 'var y = Math.max(0, (this.size[1] - textSize[1])/2);';
			str += 'this.graphics.drawString( \''+args.text+'\', this.graphics.newPen( this.graphics.PenType.SOLID_COLOR, ['+args.textRGB[0]+'/255, '+args.textRGB[1]+'/255, '+args.textRGB[2]+'/255, 1], 1 ), x, y);';
			}
		if(args.bgRGB){
			str += 'this.graphics.rectPath( 0, 0, this.size[0], this.size[1] );\
			this.graphics.fillPath( this.graphics.newBrush( this.graphics.BrushType.SOLID_COLOR, ['+args.bgRGB[0]+'/255, '+args.bgRGB[1]+'/255, '+args.bgRGB[2]+'/255, 0.5] ) );'
			}
		str += '};';
		eval( str );
		//активируем изменения
		uiObject.enabled = !uiObject.enabled;
		uiObject.enabled = !uiObject.enabled;
		}catch(err){this.alertError(err)};
		},
	addFont: function( uiObject, args ){// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Regular, Bold, Italic, Bolditalic)
		if( args ){
			try{
			if( args.font || args.style || args.size ){
				args.font = args.font || uiObject.graphics.font.name;
				args.style = args.style || uiObject.graphics.font.style;
				args.size = args.size || uiObject.graphics.font.size;
				return uiObject.graphics.font = ScriptUI.newFont(args.font, args.style, args.size);
				}
			else//если через args передан uiobject
				return uiObject.graphics.font = args.graphics.font;
			}catch(err){}
			}
		try{ return uiObject.graphics.font }catch(err){ return false }
		},
	addColor: function( uiObject, type, RGB ){//type: 0 = backgroundColor, 1 = foregroundColor (fontColor), RGB - Array or uiobject. Return uiObject.graphics.[type]Color or false
		if( RGB ){
			try{
			if( !type )
				return uiObject.graphics.backgroundColor = ( RGB instanceof Array ) ? uiObject.graphics.newBrush(uiObject.graphics.BrushType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, 1]) : RGB.graphics.backgroundColor;
			else
				return uiObject.graphics.foregroundColor = ( RGB instanceof Array ) ? uiObject.graphics.newPen(uiObject.graphics.PenType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, 1], 2) : RGB.graphics.foregroundColor;
			}catch(err){}
			}
		//если не указан RGB - просто возвращаем color объекта
		try{ 
			if( !type )
				return uiObject.graphics.backgroundColor;
			else
				return uiObject.graphics.foregroundColor;
			}catch(err){ return false }
		},
	resizeWindow: function( window, sizeIndex, value ){//sizeIndex: 0 - hor, 1 - vert
		try{
		var size = [0,0];
		size[sizeIndex] = value;
		var location = [window.location[0], window.location[1]];
		var bounds = [window.bounds[0], window.bounds[1], window.bounds[2], window.bounds[3]];
		window.location = location;
		window.bounds = [bounds[0], bounds[1], bounds[2]+size[0], bounds[3]+size[1]];
		window.location = location;
		}catch(err){ this.alertError( err ); }
		},
	confirm: function( tittle, message, multiline ){
		var result = undefined;
		var win = new Window( 'dialog', tittle );
		win.alignChildren = 'right';
		win.margins = 5;
		win.spacing = 5;
		with(win){
			if( message )
				win.Text = add('statictext', undefined, message, {multiline:multiline});
			win.Grp = add('group');
			win.Grp.orientation = 'row';
			win.Grp.spacing = 5;
			with(win.Grp){
				win.Grp.Cancel = add('button', undefined, 'Cancel');
				win.Grp.no = add('button', undefined, 'No');
				win.Grp.ok = add('button', undefined, 'OK');
				}
			}
		win.Grp.Cancel.onClick = function(){
			this.window.close();
			}
		win.Grp.no.onClick = function(){
			result = false;
			this.window.close();
			}
		win.Grp.ok.onClick = function(){
			result = true;
			this.window.close();
			}
		win.center();
		win.show();
		return result;
		},
	getReportWindow: function( reportText, tittle, reportName, width ){//ОКНО ВЫВОДА РЕЗУЛЬТАТОВ
		tittle = tittle || '';
		width = width || 400;
		var _height = String( reportText ).split('\r').length;
		if( _height == 1 ) _height = 22;
		else _height = ( _height < 20 ) ? 15*_height : 300;
		var winReport = new Window( 'dialog', tittle, undefined, {resizeable:true} );
		winReport.alignChildren = 'left';
		winReport.margins = 5;
		winReport.spacing = 10;
		with(winReport){
			if( reportName ){
				winReport.Name = add('statictext', undefined, reportName, {multiline:true});
				winReport.Name.preferredSize = [ width, winReport.Name.preferredSize[1] ];
				}
			if( File.fs == 'Windows' )
				winReport.Text = add('edittext', undefined, reportText, {multiline:true, readonly:true});
			else
				winReport.Text = add('edittext', undefined, reportText, {multiline:true});
			winReport.Text.preferredSize = [ width, _height ];
			winReport.ok = add('button', undefined, 'OK');
			winReport.ok.alignment = 'center';
			};
		winReport.ok.onClick = function(){
			this.window.close();
			}
		//====================== RESIZE
		this.addDynamicObject( winReport.Text, false, [1,1], true );// moveCoefs, resizeCoefs: [horizontal, vertical]
		this.addDynamicObject( winReport.ok, ['center',1] );// moveCoefs, resizeCoefs: [horizontal, vertical]
		if( winReport.Name )
			this.addDynamicObject( winReport.Name, false, [1,0]);// moveCoefs, resizeCoefs: [horizontal, vertical]

		winReport.center();
		winReport.show();
		},
	getProgressBar: function( container, maxValue, size, location ){//возвращает progressbar с ф-цией setValue( [num] )
		size = size || [200, 8];
		location = location || [0,0];
		var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], 0, maxValue);
		pBar.setValue = function( num ){
			num = num || 1;
			if( this.value >= maxValue ) this.value = 0;
			this.value += num;
			};
		return pBar;
		},
	getProgressWindow: function( maxValue, title ){//return palette{ setValue: function( [num] ) }
		title = title || 'Progress';
		var myProgressPanel = new Window('palette', title);
		myProgressPanel.progressBar = this.getProgressBar( myProgressPanel, maxValue );
		myProgressPanel.setValue = function( num ){
			this.progressBar.setValue( num );
			}
		return myProgressPanel;
		},
	addDynamicObject: function( obj, moveCoefs, resizeCoefs, minLock, directions ){//moveCoefs: [horizontal, vertical], resizeCoefs: [horizontal, vertical], minLock: true/false, directions: [horizontal, vertical], 
		try{
		var win = ( obj instanceof Array ) ? obj[0].window : obj.window;
		if( !win.properties || !win.properties.resizeable ){
			if( win.properties && win.properties.Error ) return;//повторные сообщения не показываем
			alert('error: window.properties.resizeable = false');
			if( win.properties )
				win.properties.Error = true;
			else 
				win.properties = {Error:true};
			return;
			}
		if( !win.onResize ){
			win.properties.Objs = [];
			win.properties.String = '';
			win.properties.functString = 'this.onResize = function(){';
			if( directions && (!directions[0] || !directions[1]) ){
				if( !directions[0] ){
					win.properties.functString += 'this.bounds = [this.location[0],this.location[1], this.location[0]+this.properties.Size[0], this.location[1]+this.size[1]];';
					win.properties.functString += 'this.properties.Resize = [0, this.size[1]-this.properties.Size[1]];';
					}
				else{
					win.properties.functString += 'this.bounds = [this.location[0],this.location[1], this.location[0]+this.size[0], this.location[1]+this.properties.Size[1]];';
					win.properties.functString += 'this.properties.Resize = [this.size[0]-this.properties.Size[0], 0];';
					}
				}
			else
				win.properties.functString += 'this.properties.Resize = [this.size[0]-this.properties.Size[0], this.size[1]-this.properties.Size[1]];';
			if( minLock ){
				win.properties.functString += 'if( this.size[0] < this.properties.Size[0] ) this.size = [this.properties.Size[0], this.size[1]];';
				win.properties.functString += 'if( this.size[1] < this.properties.Size[1] ) this.size = [this.size[0], this.properties.Size[1]];';
				}
			win.onResize = function(){
				try{
				this.properties.Size = [this.size[0], this.size[1]];
				for( var i = 0; i < this.properties.Objs.length; i++ ){
					if ( !this.properties.Objs[i].properties ) this.properties.Objs[i].properties = {};
					this.properties.Objs[i].properties.Location = [this.properties.Objs[i].location[0],this.properties.Objs[i].location[1]];
					this.properties.Objs[i].properties.Size = [this.properties.Objs[i].size[0], this.properties.Objs[i].size[1]];
					}
				eval( this.properties.functString + this.properties.String + '}'  );
				}catch(err){alert(err + '\r' + err.line) }
				}
			}
		if( obj instanceof Array )
			for( var i = 0; i < obj.length; i++ )
				this.getStringForDynamicObject( obj[i], moveCoefs, resizeCoefs );
		else
			this.getStringForDynamicObject( obj, moveCoefs, resizeCoefs );
		}catch(err){ this.alertError(err) }
		},
	getStringForDynamicObject: function( obj, moveCoefs, resizeCoefs ){//for addDynamicObject();
		try{
		var win = obj.window;
		win.properties.Objs[win.properties.Objs.length] = obj;//регистрируем объект
		var sObj = 'this.properties.Objs['+(win.properties.Objs.length-1)+']';
		var string = '';
		if( moveCoefs && ( moveCoefs[0] || moveCoefs[1] ) ){
			var thisLocations = [
				sObj + '.properties.Location[0]' + ( moveCoefs[0] ? '+this.properties.Resize[0]' + (moveCoefs[0]==1?'':'*'+moveCoefs[0]) : '' ),
				sObj + '.properties.Location[1]' + ( moveCoefs[1] ? '+this.properties.Resize[1]' + (moveCoefs[1]==1?'':'*'+moveCoefs[1]) : '' )
				];
			if( moveCoefs[0] == 'center' ) thisLocations[0] = '('+sObj + '.parent.size[0]-'+sObj+'.size[0])/2';
			if( moveCoefs[1] == 'center' ) thisLocations[1] = '('+sObj + '.parent.size[1]-'+sObj+'.size[1])/2';
			
			string += sObj + '.location = [' + thisLocations.join(',') + '];';
			}
		if( resizeCoefs && ( resizeCoefs[0] || resizeCoefs[1] ) )
			string += 
				sObj+'.size = ['+
					sObj + '.properties.Size[0]' + ( resizeCoefs[0] ? '+this.properties.Resize[0]' + (resizeCoefs[0]==1?'':'*'+resizeCoefs[0]) : '' ) + ',' +
					sObj + '.properties.Size[1]' + ( resizeCoefs[1] ? '+this.properties.Resize[1]' + (resizeCoefs[1]==1?'':'*'+resizeCoefs[1]) : '') +
				'];';
		win.properties.String += string;
		}catch(err){ this.alertError(err) }
		},
	};

//====================== RESOURCES
var addScriptImages = function(){
	try{
	var code = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\n\x00\x00\x00\n\b\x06\x00\x00\x00\u008D2\u00CF\u00BD\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\x18IDATx\u00DAb\u00FC\u00FF\u00FF?\x03\b\u009C\u009D\u0095\x0E\u00A2\u00F6\x03\u00B1\x03\x03\x04\x1C\x00bG\u00E3\u00B4\u0099`\x0E\x13T\u0090\u00E1\u00EC\u00D9\u00B3\u00FB\x19x\u00A5\x1C\u008C}\u00D2\x18@\x18\u00C4\x06\u008BA\x01\x0B\u00D0\u00A4\u00FD\u00AC\x1C\\`SD\x04\u00F9\x19f5\u0082Mfp\x0F\u008C\x01Q\x0E\u0097\x16\x15\u00FE\u00FF\u00FD\u00E3\u00DB\x01\u00C6\u00BD]\u00E1\u00FF\u009D\u00A2K\x19\u00F0\u0081}K\u00BB\x19X^\u00BF~\u00CD\u00F0\u00E3\u00CB\x07\u00B0\u00C0\u00DB\u00BB\u00C5\f?\u00BF\\\x04\u00B3\u00D9y\u00F4\x19\u0084\u0095{\u00C1l\u0090\x1A\u00C6\u0099i\u00C6\u00FF9\u00B8x\x18x\u00F9\x05\x19D\u008560\u00D8\u00E4\u00DD\x05K\x1E\u0099\u00A4\u00CC\u00F0\u00FA]\x00\u00C3\u00E7\u008F\u00EF\x19~|\u00FB\u00C2\u00C0\"**\u00CA`h\u00ED\x02\u0096\u00BCq\u00F12\u00C3\u00EA\ne0\u009BW@\u0099\u00C1\u00D0\u00DC\x06\u00CC>\x7Ft\x0F\x03\u00CB\u00F7\u00EF\u00DF\x19\u00BE\u00BE\x7F\t\x16\u0090\u0095\x0Bb`\u0090C\u00B8\r&\x0ER\u00C3\u00F2\u00F3\u00E7O\u00A0\x1B?\u00E2\u00F5\fH\r\u00CB\u00EF\u00DF\u00BF\x0F\\\u00BAt\u00C9\u0081\u0083\u0083\u0083\u0081\u009D\u009D\u009D\u0081\u008D\u008D\r,\u00F9\u00EB\u00D7/\u00B0\u0082\x1F?~0\u0080\u00D4\x00\x04\x18\x00\u00E6\u008BoE\r\u0090U\u00A8\x00\x00\x00\x00IEND\u00AEB`\u0082";
	script.writeImage(code, 'folder');
	var code = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\n\x00\x00\x00\n\b\x06\x00\x00\x00\u008D2\u00CF\u00BD\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00A4IDATx\u00DAb\u00FC\u00FF\u00FF?\x031\u0080%}\u00D6\u00D9\u00FD@\u00DA\x01\u0088\x19\u0091\u00C41\u00C4\u0098~\u00FF\u00FE\u00ED\u0090\u00E6c\u00CC\x00\u00A4\u00FF\u00CFL3f\x00at1 \u00CD\u00C0\u00F4\u00F3\u00E7O\u00B0\u008E\u00EC@\x0B\u0086\u00E8\u00BE\u0083`w\u00A0\u008B\u0081\u00F8L\u00DF\u00BF\x7Fg\u00F8\b\x14\x07\u00E1\u00A2\b{\u0086\u00A0\u00D6\x1D\u00FB\u00D1\u00C5\u0080\u00FC\u00FF, \u00C1\u00D7_!\u00EE\u00B8|\u00FF\rH\x10\u00CCF\x17\u0083\u009Bx\u00EB\u00D1K\u0086\u00F5[w1\x04\x06\x06:\u00A2\u008B\x01\u00F9\u008C`7\u00BEx\u00F1\u0082a\u00DB\u00B6m\fQQQ\u008C07\"\u008B\u0081\u00F8\u008C\u00C6i3\u0089\n\x1EFb\x03\x1C \u00C0\x00\u0084\x11\u0086\u00D0\u00EF\u00863C\x00\x00\x00\x00IEND\u00AEB`\u0082";
	script.writeImage(code, 'file');
	var code = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\n\x00\x00\x00\n\b\x06\x00\x00\x00\u008D2\u00CF\u00BD\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00E8IDATx\u00DAlP\u00AD\x0E\u0083@\f.\x0B\x0E\u0087B\u00E0x\x01\x1E\u0081#3s(\x04O2\u00C7\u00E6\u00F6(\x0B\u0086\x17X\x02\x12C\x00\x01\u008E\x04\u0089\x01\u0081\u00E0'\u0088\u00DB\u00F5\u00C21H\u00D6\u00E4\u00BB\u00F6\u00BE~\u00ED\u00B5'QJ\u00C1\u00FD\u00B8\u00C0\u008C\u00C2\x7F\u008B\u0083k@d\u008C\u00D6u\u00E5\u0084\u00AE\u00EB\x16\u00C3I\u0095$\u0089\u0085\u00FE\u0082\u00C7\u00B2,\x10\u00DEBR\u00D7u\u00CC\u00C0\x05\u00F3<s`\x0EM\x16\u00A4\u00FD\u00B6\u00B1\u00D22\f\x03\u00BA\u00AE\u00DB;bn\x17N\u00D3\u0084\u00A2\u00C8q\x1Ch\u009A\u0086'\u00DA\u00B6\x05M\u00D30\u00F7\x13\u008E\u00E3\x18y\u009E\x07eYr\u00B2(\n>3\u00E3-\u0086SGH\u00D3\u0094\x13y\u009E\u0083i\u009A\u00D2\x16G8\u00CE\u00BE\f\u00CE1\f\x03TU\u00851\x11\u00F3\u00B1\x02\u00C2\u00EE\u00D2qk\u0092e\x19(\u008A\u0082\u00B1\x7F\u00FC\x1E\u00B1\u00B5\u0084\x1F\u00AE\u00DEU\u00D8\u009E\u00F07\u00FFdx\bq\u00FF\u00EA\u00E1+\u00C0\x00=*z\x1C{\u00EA\x15\u00F8\x00\x00\x00\x00IEND\u00AEB`\u0082";
	script.writeImage(code, 'aliasFolder');
	}catch(err){script.alertError(err)};
	}
addScriptImages();

main();

function main(){
	try{
	if( !script.systemCheck() )
		return;
	
	getDefault();
	res = script.prefRead( true );
	if(res)
		eval( res );
	//====================== WIN
	win = new Window((/(InDesign|Illustrator)/.test(script.appName))?"window":"dialog", script.name, getWinBounds(), {resizeable:true});
	with(win){
		win.buts = add("group", [5,5,450,30], undefined);
		with(win.buts) {
			win.buts.open = add("button", [0,0,70,22], "Open");
			win.buts.play = add("button", [80,0,150,22], "Play");
			win.buts.list = add("button", [160,0,230,22], "List");
			win.buts.info = add("button", [240,0,310,22], "Info");
			win.buts.close = add("button", [320,0,390,22], "Close");
			}
		win.player = add("flashplayer", [5,35,395,335], undefined);
		win.list = addExplorer({
			container: win, 
			location: [5, 345],
			size: [390,135],
			FILES: [
				{type: 'swf', event: function(){loadSWF(File(this.Link))}}
				], 
			CURRENT_FOLDER: CURRENT_FOLDER, 
			IMAGE_FILE: script.images['file'],
			IMAGE_FOLDER: script.images['folder'],
			IMAGE_ALIAS_FOLDER: script.images['aliasFolder']
			});
		}
	win.buts.play.enabled = false;

	//====================== OPEN
	win.buts.open.onClick = function(){
		var file = File.openDialog('Open', "File:*.swf");
		if(!file)
			return;
		loadSWF(file);
		}
	//====================== PLAY
	win.buts.play.onClick = function(){
		if(this.text == 'Play'){
			win.player.playMovie();
			this.text = 'Stop';
			}
		else{
			win.player.stopMovie();
			this.text = 'Play';
			}
		}
	//====================== RESIZE
	win.onResize = function() {
		win.player.size=[win.size[0]-10,win.size[1]-WIN_RESIZE_VAR[WIN_LIST]];
		win.list.getResize(
			[win.list.location[0], win.player.bounds[3]+10], //newLocation
			[win.size[0]-10,win.list.size[1]],//newSize
			);
		}
	//====================== LIST
	win.buts.list.onClick = function(){
		if(WIN_LIST){
			WIN_LIST = 0;
			var res = -145;
			}
		else{
			WIN_LIST = 1;
			var res = 145;
			}
		script.resizeWindow( this.window, 1, res );
		}

	//====================== INFO
	win.buts.info.onClick = function(){
		script.getWinInfo();
		}
	//====================== CLOSE
	win.buts.close.onClick = function(){
		this.window.close();
		}
	win.onClose = function(){
		script.prefSave( getPrefStr(this.player.size, this.location, win.list.CURRENT_FOLDER), true );
		win.remove(win.player);
		}

	CURRENT_FOLDER = win.list.loadList(CURRENT_FOLDER);
	win.onResize();
	win.show();
	}catch(err){script.alertError(err)};
	}

//========================================================================================
//========================================================================================
function getDefault(){
	WIN_RESIZE_VAR = [40, 185];
	playerSize = [390,300];
	WIN_LIST = 0;
	winLocation = getWinLocation_Center();//default - center
	CURRENT_FOLDER = Folder.desktop;
	}

function loadSWF(file){
	if(win.text != script.name){
		eval('var size = [' + win.player.size.toString() + '];');
		win.remove(win.player);
		win.player = win.add('flashplayer', [5,35,5+size[0],35+size[1]]);
		}
	win.player.loadMovie(file);
	win.text = script.name +' - ' + file.displayName;
	win.buts.play.enabled = true;
	win.buts.play.text = 'Stop';
	}

function getPrefStr(playerSize, winLocation, CURRENT_FOLDER){
	var str = 
	'playerSize = [' + playerSize.toString() + '];\n' +
	'WIN_LIST = ' + WIN_LIST + ';\n' +
	'winLocation = ['+winLocation.toString()+'];\n' +
	'CURRENT_FOLDER = Folder(\'' + CURRENT_FOLDER.fullName + '\');';
	return str;
	}

function getWinLocation_Center(){
	var winSize = [playerSize[0]+10, playerSize[1]+WIN_RESIZE_VAR[WIN_LIST]];
	return [Math.round(($.screens[0].right - winSize[0])/2), Math.round(($.screens[0].bottom - winSize[1])/2)]
	}
function getWinBounds(){
	return [winLocation[0],winLocation[1],winLocation[0]+playerSize[0]+10, winLocation[1]+playerSize[1]+WIN_RESIZE_VAR[WIN_LIST]];
	}

//====================== EXPLORER
function addExplorer(args){
	/*args = { 
		container: objectUI
		location: [x, y]. Optional. Default: after the last container object
		size: [x, y]. Optional.  Default: [(width of container)-10, 140]. Minimum values: [40, 40]
		FILES: [args, args, args, ...]. Optional. Default: all files
					args = {
						type: 'eps'
						event: function (event on the double click mouse). Optional
						image: ScriptUIImage (.png, 10x10). Optional. 
						}
		CURRENT_FOLDER: folder. Optional. Default: Folder.desktop
		IMAGE_FILE: ScriptUIImage (.png, 10x10). Optional.
		IMAGE_FOLDER: ScriptUIImage (.png, 10x10). Optional.
		IMAGE_ALIAS_FOLDER: ScriptUIImage (.png, 10x10). Optional.
		}*/
	try{
	var container = args.container;
	var getBounds = function(){
		var size = args.size || [container.bounds[2]-10, 140];
		size[0] = (+size[0] < 40) ? 40 : size[0];
		size[1] = (+size[1] < 40) ? 40 : size[1];
		var location = args.location || false;
		if(location&&location.constructor.name=='Array'&&location.length==2){
			}
		else{
			if(container.children.length > 0)
				location = [5, container.children[container.children.length-1].bounds[3]+5];
			else
				location =  [5,5];
			}
		return[location[0], location[1], location[0]+size[0], location[1]+size[1]];
		}
	var explorer = container.add('group', getBounds());
	explorer.CURRENT_FOLDER = args.CURRENT_FOLDER || Folder.desktop;
	explorer.FILES = args.FILES || [{type: '*'}];
	explorer.IMAGE_FILE = args.IMAGE_FILE || false;
	explorer.IMAGE_FOLDER = args.IMAGE_FOLDER || false;
	explorer.IMAGE_ALIAS_FOLDER = args.IMAGE_ALIAS_FOLDER || false;
	var LINK_INDENT = (explorer.IMAGE_FOLDER) ? 30 : 80;
	with(explorer) {
		if(explorer.IMAGE_FOLDER)
			explorer.folder = add("iconbutton", [0,0,22,22], IMAGE_FOLDER);
		else
			explorer.folder = add("button", [0,0,75,22], 'Folder');
		explorer.link = add("edittext", [LINK_INDENT, 2, explorer.size[0], 22], undefined, {readonly: true});
		explorer.box = add("listbox", [0, 27, explorer.size[0], explorer.size[1]]);
		}
	explorer.getResize  = function(newLocation, newSize){
		this.location = newLocation;
		this.size = newSize;
		this.link.size = [this.size[0] - this.link.location[0], this.link.size[1]];
		this.box.size = [this.size[0], this.box.size[1]];
		}
	explorer.folder.onClick = function(){
		var folder = Folder.selectDialog('Select folder', this.parent.CURRENT_FOLDER);
		if(folder)
			this.parent.loadList(folder);
		}
	explorer.loadList = function(folder){
		if(!folder.exists)
			return this.link.text;//return current folder fsName
		this.box.removeAll();
		if(folder.parent != null){
			item = this.box.add('item', '...');
			item.Type = 'level';
			if(this.IMAGE_FOLDER)
				item.image = this.IMAGE_FOLDER;
			}
		for(var i=0;i<this.FILES.length;i++){
			var files = folder.getFiles('*.' + this.FILES[i].type);
			for(var j=0;j<files.length;j++){
				item = this.box.add('item', files[j].displayName);
				item.Link = files[j].fsName;
				item.Type = 'file';
				item.Event = this.FILES[i].event || function(){};
				var image = this.FILES[i].image || this.IMAGE_FILE;
				if(image)
					item.image = image;
				}
			}
		var folders = folder.getFiles(function(file) { return file instanceof Folder });
		for(var i=0;i<folders.length;i++){
			item = this.box.add('item', folders[i].displayName);
			item.Link = folders[i].fsName;
			item.Type = 'folder';
			if(this.IMAGE_FOLDER)
				item.image = this.IMAGE_FOLDER;
			}
		var alias = folder.getFiles(function(file) { return file.alias});
		var aliasFolder = [];
		for(var i=0;i<alias.length;i++)
			if(alias[i].resolve() instanceof Folder)
				aliasFolder.push(alias[i]);
		for(var i=0;i<aliasFolder.length;i++){
			item = this.box.add('item', aliasFolder[i].displayName);
			item.Link = aliasFolder[i].resolve().fsName;
			item.Type = 'aliasFolder';
			if(this.IMAGE_ALIAS_FOLDER)
				item.image = this.IMAGE_ALIAS_FOLDER;
			}
		this.CURRENT_FOLDER = folder;
		this.link.text = folder.fsName;
		return folder;//return current folder
		}
	explorer.box.onDoubleClick = function(){
		switch(this.selection.Type){
			case 'level':
			this.parent.CURRENT_FOLDER = this.parent.loadList(this.parent.CURRENT_FOLDER.parent);
			break;
			case 'folder':
			case 'aliasFolder':
			this.parent.CURRENT_FOLDER = this.parent.loadList(Folder(this.selection.Link));
			break;
			case 'file':
			var file = File(this.selection.Link);
			if(!file.exists)
				return;
			this.selection.Event();
			}
		}
	} catch(err){
		script.alertError(err);
		return false;
		}
	return explorer;
	}

